
#include "Wire.h"
#include <LiquidCrystal_SR.h>
#include <AFMotor.h>                                // for DC Motor

/**************************************/
/******DEFINING PIN ALLOCATIONS *******/
/**************************************/

const int trigPin = 10;
const int echoPin = 11;

// Defining LCD and Pins for interfacing.
LiquidCrystal_SR lcd(6, 5, 9);                     // Pin 6 - Data Enable/ SER,      Pin 5 - Clock/SCL,       Pin 9 -SCK

// defines variables
long duration;
int distance;

AF_DCMotor motorR(2, MOTOR12_64KHZ);                // create motor #1, 64KHz pwm

/******************************************/
/**************SETUP **********************/
/*****************************************/

void setup() {
  pinMode(trigPin, OUTPUT);                         // Sets the trigPin as an Output
  pinMode(echoPin, INPUT);                          // Sets the echoPin as an Input
  Serial.begin(9600);                               // Starts the serial communication
  motorR.setSpeed(250);
  lcd.begin(16, 2);                                 // originally 16 characters, 2 rows
  lcd.cursor();
}

void loop()
{
  lcd.setCursor(0, 0);
  lcd.print("WAVE IN FRONT OF");
  lcd.setCursor(0, 1);
  lcd.print("SENSOR FOR SOAP");

  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);

  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);

  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);

  // Calculating the distance
  distance = duration * 0.034 / 2;

  // Prints the distance on the Serial Monitor
  Serial.print("Distance: ");
  Serial.println(distance);
  delay(200);
  //Servo
  if (distance < 10)                                //Check distance is less than 10cm
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("PLACE PALM UNDER ");
    lcd.setCursor(0, 1);
    lcd.print("DISPENSER... ");
    
    delay(3000);
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("DISPENSING....");
    motorR.run(FORWARD);                          // Drive Forward
    lcd.setCursor(0, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(1, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(2, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(3, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(4, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(5, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(6, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(7, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(8, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(9, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(10, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(11, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(12, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(13, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(14, 1);
    lcd.print(">");
    delay(100);
    lcd.setCursor(15, 1);
    lcd.print(">");
    //delay(100);
    
    delay (2000);
    motorR.run(RELEASE);                         // Motor stopped
    lcd.clear();
    lcd.setCursor(0, 1);
    lcd.print("THANK YOU !!   ");
    delay (2000);
    lcd.clear();

  }
}
